
#property copyright "TkPower8 ATM v1.5c"
#property link      "TKPower8"

#property indicator_chart_window
#property indicator_buffers 2

extern bool    SoundOn              = true;
extern bool    TextLabelsOn         = false;
extern bool    SignalOnAll_C_eats_C = false;


extern int     PipDelta             = 1;

extern int     ArrowPlace           = 5;
extern bool    PlaceArrowAt_C_eats_C= false;
extern int     ArrowSize            = 1;
extern color   UP                   = Lime;
extern color   DOWN                 = Red;

int            ArrowCodeUp          = 233;
int            ArrowCodeDn          = 234;
datetime       oldbar               = 0;
double         buy[], sell[];

extern string  FastInputs           = "=====================================";
extern int     FastMAPeriod         = 8;
extern int     FastMAType           = 0;
extern string  Note_OnSetSlope      = "Inputs Are Degrees Of Angle"; 
extern double  SetFastMA_UpMinSlope = 30;
extern double  SetFastMA_DnMinSlope = -30;
extern int     BarsBackForFastSlope = 5;

extern string  SlowIputs            = "=====================================";
extern int     SlowMAPeriod         = 21;
extern int     SlowMAType           = 0;
extern string  NoteOnSetSlope       = "Inputs Are Degrees Of Angle";
extern double  SetSlowMA_UPMinSlope = 1;
extern double  SetSlowMA_DnMinSlope = -1;
extern int     BarsBackForSlowSlope = 5;


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
      if ( Digits == 3 || Digits == 5 )
         {
            PipDelta   = PipDelta*10;
            ArrowPlace = ArrowPlace*10;
         }
      
      if (PlaceArrowAt_C_eats_C)
         {
            ArrowCodeUp = 231;
            ArrowCodeDn = 231;
         }
      
      
      SetIndexBuffer(0, buy);
      SetIndexStyle(0, DRAW_ARROW,0,ArrowSize,UP);
      SetIndexArrow(0,  ArrowCodeUp);
      SetIndexLabel(0, "ATM ED2 Up Signal");
      
      SetIndexBuffer(1, sell);
      SetIndexStyle(1, DRAW_ARROW,0,ArrowSize,DOWN);
      SetIndexArrow(1,  ArrowCodeDn);
      SetIndexLabel(1, "ATM ED2 Down Signal");

      
      
      for(int i = 0; i < ObjectsTotal(); i++)
     {
       if(StringFind(ObjectName(i), "txt_", 0) == 0)
         {
           ObjectDelete(ObjectName(i));
           i--;
         }
     }
       
//----
   return(0);
  }
//+----------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   Comment("");
   
   for(int i = 0; i < ObjectsTotal(); i++)
     {
       if(StringFind(ObjectName(i), "txt_", 0) == 0)
         {
           ObjectDelete(ObjectName(i));
           i--;
         }
     }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
      bool long, short;
      string on;
      int limit;
      int counted_bars=IndicatorCounted();
      //---- last counted bar will be recounted
      if(counted_bars>0) counted_bars--;
      limit=Bars-counted_bars;
   
      for(int i=0; i<limit; i++)   
         {
            long = false;
            short = false;
            
            sell[i]  = 0;
            buy[i]   = 0;
                      
            
            if ( setslope(SetFastMA_UpMinSlope, "fup", i) ) long  = true;
            if ( setslope(SetSlowMA_UPMinSlope, "sup", i) ) long  = true;
            if ( setslope(SetFastMA_DnMinSlope, "fdn", i) ) short = true;
            if ( setslope(SetSlowMA_DnMinSlope, "sdn", i) ) short = true;
            
            if (SignalOnAll_C_eats_C)
               {
                  long  = true;
                  short = true;
               }
            
            if ( tkpower8ATM("up", i) && long )
               {
                  if (PlaceArrowAt_C_eats_C)
                     buy[i] = High[i+1]+(PipDelta*Point);
                  if(PlaceArrowAt_C_eats_C == false)
                     buy[i] = Low[i] - ArrowPlace*Point;   
                  if (TextLabelsOn)
                     {
                        on = "txt_" + Time[i];
                        ObjectDelete(on);
                        ObjectCreate(on, OBJ_TEXT, 0, Time[i], Low[i] - iATR(NULL, 0, 14, i));
                        ObjectSetText(on, DoubleToStr(High[i+1]+(PipDelta*Point),Digits) + " " + TimeToStr(Time[i], 
                                      TIME_MINUTES), 8, "Arial", UP);
                     }                  
               }
            
            if ( tkpower8ATM("down", i) && short )
               {
                  
                  if (PlaceArrowAt_C_eats_C)
                     sell[i] = Low[i+1]-(PipDelta*Point);
                  if (PlaceArrowAt_C_eats_C == false)
                     sell[i] = High[i] + ArrowPlace*Point;   
                  if (TextLabelsOn)
                     {
                        on = "txt_" + Time[i];
                        ObjectDelete(on);
                        ObjectCreate(on, OBJ_TEXT, 0, Time[i], High[i] + iATR(NULL, 0, 14, i));
                        ObjectSetText(on, DoubleToStr(Low[i+1]-(PipDelta*Point),Digits) + " " + TimeToStr(Time[i], 
                                       TIME_MINUTES), 8, "Arial", DOWN);
                     }                     
               }    
         }
      
      if (SoundOn)
         {
            if ( buy[0] != 0 && oldbar != Time[0] )
               {   
                  Alert("ATM ED2 Up Signal on ",Symbol()," ",Period(),"M at ",Hour(),":",Minute(),":",Seconds());
                  oldbar = Time[0];
               } 
               
            if ( sell[0] != 0 && oldbar != Time[0] )
               {   
                  Alert("ATM ED2 Down Signal on ",Symbol()," ",Period(),"M at ",Hour(),":",Minute(),":",Seconds());
                  oldbar = Time[0];
               }        
         }
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+


   
bool tkpower8ATM(string type, int i ) 
{
      if (Close[i+1] < Open[i+1] &&  High[i] >= High[i+1] + PipDelta*Point && type == "up" ) 
          {
               return(true);
          }
      if (Close[i+1] > Open[i+1] && Low[i] <= Low[i+1] - PipDelta*Point && type == "down" ) 
          {
               return(true);
          }
        
  
   return(false);
}   


bool   setslope(double maslope, string name, int i)
   {
      double delta = 1;
      double OriginF   = iMA(Symbol(),0, FastMAPeriod, 0, FastMAType, PRICE_CLOSE, i+BarsBackForFastSlope);
      double AdjacentF = iMA(Symbol(),0, FastMAPeriod, 0, FastMAType, PRICE_CLOSE, i);
      double OriginS   = iMA(Symbol(),0, SlowMAPeriod, 0, SlowMAType, PRICE_CLOSE, i+BarsBackForSlowSlope);
      double AdjacentS = iMA(Symbol(),0, SlowMAPeriod, 0, SlowMAType, PRICE_CLOSE, i);
      double Slope = maslope / 45;
      
      if ( PipDelta >= 10 ) delta = 10;
      double RiseF = (AdjacentF - OriginF) / Point / delta;
      double RiseS = (AdjacentS - OriginS) / Point / delta;
    
      if ( maslope == SetFastMA_UpMinSlope && name == "fup" )
         if ( RiseF/BarsBackForFastSlope >= Slope )
            return(true);            

      if ( maslope == SetFastMA_DnMinSlope && name == "fdn" )
         if ( RiseF/BarsBackForFastSlope <= Slope )
            return(true);
      
      if ( maslope == SetSlowMA_UPMinSlope && name == "sup" )
         if ( RiseS/BarsBackForSlowSlope >= Slope )
            return(true);  
            
      if ( maslope == SetSlowMA_DnMinSlope && name == "sdn" )
         if ( RiseS/BarsBackForSlowSlope <= Slope )
            return(true); 
      
      
      return(false);                            
   }
   